
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class NonconformancesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.create(
            {
                id: data.id || undefined,
        
        nc_number: data.nc_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        nonconformance_type: data.nonconformance_type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        disposition: data.disposition
        ||
        null
            ,
            
        detected_at: data.detected_at
        ||
        null
            ,
            
        closed_at: data.closed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await nonconformances.setProduct( data.product || null, {
            transaction,
        });
        
        await nonconformances.setBatch( data.batch || null, {
            transaction,
        });
        
        await nonconformances.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await nonconformances.setOwner( data.owner || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'evidence_files',
                belongsToId: nonconformances.id,
            },
            data.evidence_files,
            options,
        );
        

        return nonconformances;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const nonconformancesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                nc_number: item.nc_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                nonconformance_type: item.nonconformance_type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                disposition: item.disposition
            ||
            null
            ,
            
                detected_at: item.detected_at
            ||
            null
            ,
            
                closed_at: item.closed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const nonconformances = await db.nonconformances.bulkCreate(nonconformancesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < nonconformances.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.nonconformances.getTableName(),
                    belongsToColumn: 'evidence_files',
                    belongsToId: nonconformances[i].id,
                },
                data[i].evidence_files,
                options,
            );
        }
        

        return nonconformances;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const nonconformances = await db.nonconformances.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.nc_number !== undefined) updatePayload.nc_number = data.nc_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.nonconformance_type !== undefined) updatePayload.nonconformance_type = data.nonconformance_type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.disposition !== undefined) updatePayload.disposition = data.disposition;
        
        
        if (data.detected_at !== undefined) updatePayload.detected_at = data.detected_at;
        
        
        if (data.closed_at !== undefined) updatePayload.closed_at = data.closed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await nonconformances.update(updatePayload, {transaction});

        
        
        if (data.product !== undefined) {
            await nonconformances.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.batch !== undefined) {
            await nonconformances.setBatch(
              
              data.batch,
              
              { transaction }
            );
        }
        
        if (data.supplier !== undefined) {
            await nonconformances.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await nonconformances.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'evidence_files',
                belongsToId: nonconformances.id,
            },
            data.evidence_files,
            options,
        );
        

        return nonconformances;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of nonconformances) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of nonconformances) {
                await record.destroy({transaction});
            }
        });


        return nonconformances;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findByPk(id, options);

        await nonconformances.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await nonconformances.destroy({
            transaction
        });

        return nonconformances;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findOne(
            { where },
            { transaction },
        );

        if (!nonconformances) {
            return nonconformances;
        }

        const output = nonconformances.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.product = await nonconformances.getProduct({
            transaction
        });
        
        
        output.batch = await nonconformances.getBatch({
            transaction
        });
        
        
        output.supplier = await nonconformances.getSupplier({
            transaction
        });
        
        
        output.owner = await nonconformances.getOwner({
            transaction
        });
        
        
        output.evidence_files = await nonconformances.getEvidence_files({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.batches,
        as: 'batch',
        
        where: filter.batch ? {
          [Op.or]: [
            { id: { [Op.in]: filter.batch.split('|').map(term => Utils.uuid(term)) } },
            {
              batch_number: {
                [Op.or]: filter.batch.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              supplier_name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'evidence_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.nc_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'nc_number',
                        filter.nc_number,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.detected_atRange) {
                const [start, end] = filter.detected_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    detected_at: {
                    ...where.detected_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    detected_at: {
                    ...where.detected_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.closed_atRange) {
                const [start, end] = filter.closed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.nonconformance_type) {
                where = {
                    ...where,
                nonconformance_type: filter.nonconformance_type,
            };
            }
            
            if (filter.disposition) {
                where = {
                    ...where,
                disposition: filter.disposition,
            };
            }
            


      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.nonconformances.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'nonconformances',
                        'nc_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.nonconformances.findAll({
            attributes: [ 'id', 'nc_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['nc_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.nc_number,
        }));
    }

    
};

